﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Collections;
using MQTTnet;
using MQTTnet.Client;
using Newtonsoft.Json;
using ModbusDemo.Modular;
namespace ModbusDemo.Common
{
    public static class ModualAlarm
    {
        public const ushort usChannelNumber = 8;

        public static string sAlarmJson;
        public static string sAlarmJsonPackage;
        //private IMqttClient mqttClient = null;
        public enum eAlarmCode : ushort
        {
            ChannelNoError                  = 0,
            ChannelCommunError              = 1,
            ChannelCollectDataError         = 2,
            ChannelDataRespError            = 4,
            ChannelDataChangeError          = 8,
            ChannelLevelError               = 16,
            ChannelControlError             = 32,
            ChannelRunOverTimeError         = 64,
        }
        public static void vSetAlarmList(ushort usAddress, ushort[] usChannel, ushort[] usChannelAlarmcode)
        {
            ushort i = 0;
            Hashtable hMqtttAlarmMap = new Hashtable();
            hMqtttAlarmMap.Add("addr", usAddress.ToString());
            string sAlarm = "alm";
            foreach (ushort usdata in usChannelAlarmcode)
            {
                hMqtttAlarmMap.Add(sAlarm + usChannel[i], usChannelAlarmcode[i]);
                i++;
            }
            hMqtttAlarmMap.Add("ts", Form1.GetTimeStamp());
            if (sAlarmJson != "[")
            {
                sAlarmJson += ",";
            }
            sAlarmJson += JsonConvert.SerializeObject(hMqtttAlarmMap);

        }
        public static async Task vPublishAlarmPackageJson(IMqttClient mqttClient)
        {
            var message = new MqttApplicationMessageBuilder()
                                .WithTopic(Form1.sAlarmTopic)
                                .WithPayload(sAlarmJson)
                                .WithAtMostOnceQoS()
                                .WithRetainFlag(false)
                                .Build();
            await mqttClient.PublishAsync(message);
        }
        public static void vSet_Modual_Alarm(byte byModbusID,ushort usAlarmCodde,bool bSetAlarm,byte byCommFailTimes,params string[] strChannalList)
        {
            for (int i = 0; i < ModualPoll.byX14pNumber;i++)
            {
                if (byModbusID == ModualPoll.cx14P.byModbusID[i])
                {
                    for (int j = 0; j < strChannalList.Count(); j++)
                    {
                        for (int k = 0; k < ModualPoll.byX18xReadDataNumber; k++)
                        {
                            string strChannel = "d" + k.ToString();
                            if (strChannalList[j] == strChannel)
                            {
                                if (bSetAlarm == true)
                                {
                                    if ((usAlarmCodde & (ushort)eAlarmCode.ChannelCommunError) == (ushort)eAlarmCode.ChannelCommunError)
                                    {
                                        ModualPoll.cx14P.sX14PAlarmStruct[i].usCommFailTimes[k] += byCommFailTimes;
                                    }
                                    ModualPoll.cx14P.sX14PAlarmStruct[i].usNowAlarmCode[k] |= usAlarmCodde;
                                }
                                else
                                {
                                    if ((usAlarmCodde & (ushort)eAlarmCode.ChannelCommunError) == (ushort)eAlarmCode.ChannelCommunError)
                                    {
                                        ModualPoll.cx14P.sX14PAlarmStruct[i].usCommFailTimes[k] = 0;
                                    }
                                    ModualPoll.cx14P.sX14PAlarmStruct[i].usNowAlarmCode[k] &= (ushort)~usAlarmCodde;
                                }
                            }
                        }
                    }
                }
            }
            for (int i = 0; i < ModualPoll.byX18xNumber; i++)
            {
                if (byModbusID == ModualPoll.cx18x.byModbusID[i])
                {
                    for (int j = 0; j < strChannalList.Count(); j++)
                    {
                        for (int k = 0; k < ModualPoll.byX18xReadDataNumber; k++)
                        {
                            string strChannel = "d" + k.ToString();
                            if (strChannalList[j] == strChannel)
                            {
                                if (bSetAlarm == true)
                                {
                                    if ((usAlarmCodde & (ushort)eAlarmCode.ChannelCommunError) == (ushort)eAlarmCode.ChannelCommunError)
                                    {
                                        ModualPoll.cx18x.sX18xAlarmstruct[i].usCommFailTimes[k] += byCommFailTimes;
                                    }
                                    ModualPoll.cx18x.sX18xAlarmstruct[i].usNowAlarmCode[k] |= usAlarmCodde;
                                }
                                else
                                {
                                    if ((usAlarmCodde & (ushort)eAlarmCode.ChannelCommunError) == (ushort)eAlarmCode.ChannelCommunError)
                                    {
                                        ModualPoll.cx18x.sX18xAlarmstruct[i].usCommFailTimes[k] = 0;
                                    }
                                    ModualPoll.cx18x.sX18xAlarmstruct[i].usNowAlarmCode[k] &= (ushort)~usAlarmCodde;
                                }
                            }
                        }
                    }
                }
            }
            for (int i = 0; i < ModualPoll.byX78cNumber; i++)
            {
                if (byModbusID == ModualPoll.cx78c.byModbusID[i])
                {
                    for (int j = 0; j < strChannalList.Count(); j++)
                    {
                        for (int k = 0; k < ModualPoll.byX78cInputRegNumber + ModualPoll.byX78cOutputRegNumber; k++)
                        {
                            string strChannel = "d" + k.ToString();
                            if (strChannalList[j] == strChannel)
                            {
                                if (bSetAlarm == true)
                                {
                                    if ((usAlarmCodde & (ushort)eAlarmCode.ChannelCommunError) == (ushort)eAlarmCode.ChannelCommunError)
                                    {
                                        ModualPoll.cx78c.sX78cAlarmStruct[i].usCommFailTimes[k] += byCommFailTimes;
                                    }
                                    ModualPoll.cx78c.sX78cAlarmStruct[i].usNowAlarmCode[k] |= usAlarmCodde;
                                }
                                else
                                {
                                    if ((usAlarmCodde  & (ushort)eAlarmCode.ChannelCommunError) == (ushort)eAlarmCode.ChannelCommunError)
                                    {
                                        ModualPoll.cx78c.sX78cAlarmStruct[i].usCommFailTimes[k] = 0;
                                    }
                                    ModualPoll.cx78c.sX78cAlarmStruct[i].usNowAlarmCode[k] &= (ushort)~usAlarmCodde;
                                }
                            }
                        }
                    }
                }
            }
            for (int i = 0; i < ModualPoll.byX66cNumber; i++)
            {
                if (byModbusID == ModualPoll.cx66c.byModbusID[i])
                {
                    for (int j = 0; j < strChannalList.Count(); j++)
                    {
                        for (int k = 0; k < ModualPoll.byX66cRelayRegNumber; k++)
                        {
                            string strChannel = "d" + k.ToString();
                            if (strChannalList[j] == strChannel)
                            {
                                if (bSetAlarm == true)
                                {
                                    if ((usAlarmCodde  & (ushort)eAlarmCode.ChannelCommunError) == (ushort)eAlarmCode.ChannelCommunError)
                                    {
                                        ModualPoll.cx66c.sX66cAlarmStruct[i].usCommFailTimes[k] += byCommFailTimes;
                                    }
                                    ModualPoll.cx66c.sX66cAlarmStruct[i].usNowAlarmCode[k] |= usAlarmCodde;
                                }
                                else
                                {
                                    if ((usAlarmCodde  & (ushort)eAlarmCode.ChannelCommunError) == (ushort)eAlarmCode.ChannelCommunError)
                                    {
                                        ModualPoll.cx66c.sX66cAlarmStruct[i].usCommFailTimes[k] = 0;
                                    }
                                    ModualPoll.cx66c.sX66cAlarmStruct[i].usNowAlarmCode[k] &= (ushort)~usAlarmCodde;
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}
