﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using System.Windows.Forms;
 
namespace ModbusDemo.windows
{
     public class Totxt
    {
            private string logFile;
            private StreamWriter writer;
            private FileStream fileStream = null;
            private static object oTxtLock = new object();
            public Totxt(string fileName)
            {
                logFile = fileName;
                CreateDirectory(logFile);
            }

            public void Log(string info)
            {
                lock (oTxtLock)
                {
                    try
                    {
                        System.IO.FileInfo fileInfo = new System.IO.FileInfo(logFile);
                        if (!fileInfo.Exists)
                        {
                            fileStream = fileInfo.Create();
                            writer = new StreamWriter(fileStream);
                        }
                        else
                        {
                            fileStream = fileInfo.Open(FileMode.Append, FileAccess.Write);
                            writer = new StreamWriter(fileStream);
                        }
                        writer.WriteLine(DateTime.Now + ": " + info);
                    }
                    finally
                    {
                        if (writer != null)
                        {
                            writer.Close();
                            writer.Dispose();
                            fileStream.Close();
                            fileStream.Dispose();
                        }
                    }
                }
            }
            public void CreateDirectory(string infoPath)
            {
                DirectoryInfo directoryInfo = Directory.GetParent(infoPath);
                if (!directoryInfo.Exists)
                {
                    directoryInfo.Create();
                }
            }
        }
    }
