﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using MQTTnet;
using MQTTnet.Client;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using ModbusDemo.windows;
using ModbusDemo;
using ModbusDemo.Modular;
using ModbusDemo.Common;
using System.Threading;
using ModbusDemo.application;
using System.Windows.Forms;
namespace ModbusDemo.MessageFormat
{
    public class ModualControl
    {
        public class Op
        {
            public ushort duration { get; set; }
            public UInt64 startTime { get; set; }
            public int d0 { get; set; }
            public int d1 { get; set; }
            public int d2 { get; set; }
            public int d3 { get; set; }
            public int d4 { get; set; }
            public int d5 { get; set; }
            public int d6 { get; set; }
            public int d7 { get; set; }
            public UInt64 ts { get; set; }

        }
        public class SsItem
        {
            public string addr { get; set; }
            public Op op { get; set; }
        }

        public class MqttRoot
        {
            public string taskId { get; set; }
            public List<SsItem> ss { get; set; }
        }
        public class Cfg
        {
            public byte d0 { get; set; }
            public byte d1 { get; set; }
            public byte d2 { get; set; }
            public byte d3 { get; set; }
            public byte d4 { get; set; }
            public byte d5 { get; set; }
            public byte d6 { get; set; }
            public byte d7 { get; set; }
            public string name {get; set; }
            public string down { get; set; }
            public string upper { get; set; }
            public UInt64 ts { get; set; }
        }
        public class pcCfgSsItem
        {
            public string addr { get; set; }
            public Cfg cfg { get; set; }
        }

        public class pcCfgRoot
        {
            public string taskId { get; set; }
            public List<pcCfgSsItem> ss { get; set; }
        }

        public class pcModualControlIndex
        {
            public string srcId   { get; set; }
            public string srcType { get; set; }
            public string srcCh   { get; set; }
            public string opType  {get;  set; }
            public string resId   { get; set; }
            public string resType { get; set; }
            public string resCh   { get; set; }
            public List<string> dstCh { get; set; }
        }

        public class pcControlMap
        {
            public List<pcModualControlIndex> chMap { get; set; }
        }
        public class ModualCntrol
        {
            public bool bStartControl;
            public bool bControlStatus;
            public byte sbModbusID;
            public byte sbModualIndex;
            public bool[] bControlData;
            public ushort usDurationTime;
            public UInt64 ulStartTime;
            public bool[] bControlBit = new bool[8];
            public modual.eModualType eModualType;
            public bool  bOpenMachine;
            public string[] strOperationChannelName;
        }

        private const double OPENCURRENT  = 4.1;
        private const double CLOSECURRENT = 4;
        public class pcLiquidLevelConfig
        {
            public byte         byModbusID;
            public string       stChannelNumber;
            public double       dUpLevel;
            public double       dDownLevel;
        }
        public static List<pcLiquidLevelConfig> cPoolLevelConfig = new List<pcLiquidLevelConfig>();
        public static List<ModualCntrol> liModuualControl = new List<ModualCntrol>();
        public const ushort usDefineControlTimes = 1;
        private static object obLock = new object();
#if DEBUG_TEST
        public const string strMapCfg = "{chMap:[" +
                                                "{ \"srcId\": \"31\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d1\", \"dstCh\":[\"d1\",\"d2\"],\"resId\":\"13\",\"resType\":\"WTDR78C\",\"resCh\":\"d2\"}," +

                                                "{ \"srcId\": \"16\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d0\", \"dstCh\":[\"d0\",\"d1\"],\"resId\":\"23\",\"resType\":\"WTDR78C\",\"resCh\":\"d0\"}," +
                                                "{ \"srcId\": \"16\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d2\", \"dstCh\":[\"d2\",\"d3\"],\"resId\":\"23\",\"resType\":\"WTDR78C\",\"resCh\":\"d0\"}," +

                                                "{ \"srcId\": \"35\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d0\", \"dstCh\":[\"d0\",\"d1\"],\"resId\":\"23\",\"resType\":\"WTDR78C\",\"resCh\":\"d0\"}," +
                                                "{ \"srcId\": \"35\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d2\", \"dstCh\":[\"d2\",\"d3\"],\"resId\":\"23\",\"resType\":\"WTDR78C\",\"resCh\":\"d0\"}," + 

                                                "{ \"srcId\": \"39\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d0\", \"dstCh\":[\"d0\",\"d1\"],\"resId\":\"23\",\"resType\":\"WTDR78C\",\"resCh\":\"d0\"}," +
                                                "{ \"srcId\": \"39\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d2\", \"dstCh\":[\"d2\",\"d3\"],\"resId\":\"23\",\"resType\":\"WTDR78C\",\"resCh\":\"d0\"}," +


                                                //"{ \"srcId\": \"13\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d0\", \"dstCh\":[\"d0\",\"d1\"],\"resId\":\"23\",\"resType\":\"WTDR78C\",\"resCh\":\"d0\"}," +
                                                //"{ \"srcId\": \"13\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d2\", \"dstCh\":[\"d2\",\"d3\"],\"resId\":\"23\",\"resType\":\"WTDR78C\",\"resCh\":\"d0\"}," +
                                                //"{ \"srcId\": \"13\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d4\", \"dstCh\":[\"d4\",\"d5\"],\"resId\":\"23\",\"resType\":\"WTDR78C\",\"resCh\":\"d0\"}," +
                                                //"{ \"srcId\": \"13\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d6\", \"dstCh\":[\"d6\",\"d7\"],\"resId\":\"23\",\"resType\":\"WTDR78C\",\"resCh\":\"d0\"}," +
                                        "]}";
#endif
        public static void vGetaWay_Receive_Control(string sDataString, out string stResponseData)
        {
            List<string> strOperation = new List<string>();
            MqttRoot cControl = new MqttRoot();
            var jsonObj = new JObject();
            try
            {
                cControl = JsonConvert.DeserializeObject<MqttRoot>(sDataString);
                jsonObj  = JObject.Parse(sDataString);
            }
            catch (Exception exception)
            {
                Form1.totxt.Log(exception + "Control Mqtt Parse Fail");
            }
            for (int i = 0; i < cControl.ss.Count; i++)
            {
                bool[] bOperationStatus = new bool[8] {false,false,false,false,false,false,false,false};
                ModualCntrol cModualCntrol = new ModualCntrol
                {
                    sbModbusID     = byte.Parse(cControl.ss[i].addr),
                    usDurationTime = (ushort)(cControl.ss[i].op.duration * 60),
                    ulStartTime    = cControl.ss[i].op.startTime
                };
                cModualCntrol.bControlStatus = ModualPoll.bGet_channel_Value<bool>(cModualCntrol.sbModbusID, out cModualCntrol.bControlData, "d0", "d1", "d1", "d2", "d3", "d4", "d5");
                if (jsonObj["ss"][i]["op"] != null)
                {
                    string str;
                    for (int j = 0; j < 8; j++)
                    {
                        str = "d" + j.ToString();
                        if (jsonObj["ss"][i]["op"][str] != null)
                        {
                            if (Convert.ToBoolean(jsonObj["ss"][i]["op"].Value<int>(str)) == true)
                            {
                                cModualCntrol.bControlData[j] = true;
                                cModualCntrol.bOpenMachine = true;
                            }
                            else
                            {
                                cModualCntrol.bControlData[j] = false;
                                cModualCntrol.bOpenMachine = false;
                            }
                            cModualCntrol.bControlBit[j] = true;
                            strOperation.Add(str);
                        }
                    }
                }
                if (jsonObj["ss"][i]["op"]["ts"] != null)
                {
                    jsonObj["ss"][i]["op"]["ts"] = Form1.GetTimeStamp();
                }
                cModualCntrol.strOperationChannelName = strOperation.ToArray();
                if (cModualCntrol.bControlStatus == true && cModualCntrol.ulStartTime <= Form1.GetTimeStamp())
                {
                    //Form1.vSuspend_Poll_Control(true);
                    cModualCntrol.bStartControl = true;
                    for (int j = 0; j < cModualCntrol.strOperationChannelName.Count(); j++)
                    {
                        if (ControlMap.bControl_Map(cModualCntrol.bOpenMachine, cModualCntrol.sbModbusID, cModualCntrol.bControlData, cModualCntrol.strOperationChannelName[j]))
                        {
                            bOperationStatus[j] = ControlMap.bDelege_Operation(cModualCntrol.bControlData);
                            cModualCntrol.bControlStatus = bOperationStatus[j];
                        }
                        else
                        {
                            cModualCntrol.bControlStatus = false;
                            bOperationStatus[j]          = false;
                        }
                    }
                    //Form1.vSuspend_Poll_Control(false);
                }
                if (cModualCntrol.bControlStatus == true && cModualCntrol.strOperationChannelName.Count() <= 1)
                {
                    lock (obLock)
                    {
                        vDelete_Same_Control(cModualCntrol);
                        if (cModualCntrol.bStartControl == true && cModualCntrol.ulStartTime != 0 && cModualCntrol.bControlStatus == true)
                        {
                            liModuualControl.Add(cModualCntrol);
                        }
                        else if (cModualCntrol.bStartControl == false && cModualCntrol.ulStartTime != 0)
                        {
                           liModuualControl.Add(cModualCntrol);
                        }
                    }
                }
                for (int k = 0; k < 8; k++)
                {
                    if (cModualCntrol.bControlBit[k] == true && (cModualCntrol.bControlStatus == true || bOperationStatus[k] == true))
                    {
                        string str = "d" + k.ToString();
                        jsonObj["ss"][i]["op"][str] = 1;
                    }
                    else if (cModualCntrol.bControlBit[k] == true)
                    {
                        string str = "d" + k.ToString();
                        jsonObj["ss"][i]["op"][str] = 0;
                    }
                }
            }
            stResponseData = jsonObj.ToString();
        }

        public static void vControl_Poll()//async Task 
        {
            while (true)
            {
                lock (obLock)
                {
                    for (sbyte i = 0; i < liModuualControl.Count; i++)
                    {
                        if (liModuualControl[i].bStartControl == false)
                        {
                            if (liModuualControl[i].ulStartTime <= Form1.GetTimeStamp())
                            {
                                liModuualControl[i].bStartControl = true;
                                bool[] bControlData;
                                liModuualControl[i].bControlStatus = ModualPoll.bGet_channel_Value<bool>(liModuualControl[i].sbModbusID, out bControlData, "d0", "d1", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                                if (ControlMap.bControl_Map(liModuualControl[i].bOpenMachine, liModuualControl[i].sbModbusID, liModuualControl[i].bControlData, liModuualControl[i].strOperationChannelName[0]))
                                {
                                    liModuualControl[i].bControlStatus = ControlMap.bDelege_Operation(bControlData);
                                }
                            }
                        }
                        else
                        {
                            if ((liModuualControl[i].usDurationTime + liModuualControl[i].ulStartTime) <= Form1.GetTimeStamp())
                            {
                                bool[] bControlData;
                                string str;
                                liModuualControl[i].bControlStatus = ModualPoll.bGet_channel_Value<bool>(liModuualControl[i].sbModbusID, out bControlData, "d0", "d1", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                                for (int j = 0; j < 8; j++)
                                { 
                                    str = "d"+j.ToString();
                                    if (str == liModuualControl[i].strOperationChannelName[0])
                                    { 
                                        liModuualControl[i].bControlData[j] =  !liModuualControl[i].bControlData[j];
                                    }
                                }
                                if (ControlMap.bControl_Map(!liModuualControl[i].bOpenMachine, liModuualControl[i].sbModbusID, liModuualControl[i].bControlData, liModuualControl[i].strOperationChannelName[0]))
                                {
                                    liModuualControl[i].bControlStatus = ControlMap.bDelege_Operation(bControlData);
                                }
                                liModuualControl.Remove(liModuualControl[i]);
                                break;
                            }
                        }
                    }
                }
                Thread.Sleep(100);
            }

        }
        public static Task vControl_Res_Poll()
        {
            while (true)
            {
                for (sbyte sbEastTransitPoolIndex = 0; sbEastTransitPoolIndex < AllPond.EastTransitPoolList.Count(); sbEastTransitPoolIndex++)
                {
                    if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadRefControl == true && AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadOpenPumb == true)
                    {
                        if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].dChannelCurrent < OPENCURRENT)
                        {
                            bool[] bControlData;
                            if (ModualPoll.bGet_channel_Value<bool>(AllPond.EastTransitPoolList[sbEastTransitPoolIndex].byModbusID, out bControlData, "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7") == true)
                            {
                                if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bClose_Machine(bControlData) == true)
                                {
                                    ModualAlarm.vSet_Modual_Alarm(AllPond.EastTransitPoolList[sbEastTransitPoolIndex].byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelControlError, true, 1, AllPond.EastTransitPoolList[sbEastTransitPoolIndex].strChannelNumber);
                                }
                            }
                        }
                    }
                    if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadRefControl == true && AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadOpenPumb == false)
                    {
                        if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].dChannelCurrent > CLOSECURRENT)
                        {
                            ModualAlarm.vSet_Modual_Alarm(AllPond.EastTransitPoolList[sbEastTransitPoolIndex].byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelControlError, true, 1, AllPond.EastTransitPoolList[sbEastTransitPoolIndex].strChannelNumber);
                        }
                    }
                    Thread.Sleep(200);
                }
                for (sbyte sbEastTransitPoolIndex = 0; sbEastTransitPoolIndex < AllPond.EastTransitPoolList.Count(); sbEastTransitPoolIndex++)
                {
                    if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadRefControl == true && AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadOpenPumb == true)
                    {
                        if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].dChannelCurrent < OPENCURRENT)
                        {
                            bool[] bControlData;
                            if (ModualPoll.bGet_channel_Value<bool>(AllPond.EastTransitPoolList[sbEastTransitPoolIndex].byModbusID, out bControlData, "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7") == true)
                            {
                                if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bClose_Machine(bControlData) == true)
                                {
                                    ModualAlarm.vSet_Modual_Alarm(AllPond.EastTransitPoolList[sbEastTransitPoolIndex].byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelControlError, true, 1, AllPond.EastTransitPoolList[sbEastTransitPoolIndex].strChannelNumber);
                                }
                            }
                        }
                    }
                    if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadRefControl == true && AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadOpenPumb == false)
                    {
                        if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].dChannelCurrent > CLOSECURRENT)
                        {
                            ModualAlarm.vSet_Modual_Alarm(AllPond.EastTransitPoolList[sbEastTransitPoolIndex].byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelControlError, true, 1, AllPond.EastTransitPoolList[sbEastTransitPoolIndex].strChannelNumber);
                        }
                    }
                    Thread.Sleep(200);
                }
                for (sbyte sbEastTransitPoolIndex = 0; sbEastTransitPoolIndex < AllPond.EastTransitPoolList.Count(); sbEastTransitPoolIndex++)
                {
                    if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadRefControl == true && AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadOpenPumb == true)
                    {
                        if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].dChannelCurrent < OPENCURRENT)
                        {
                            bool[] bControlData;
                            if (ModualPoll.bGet_channel_Value<bool>(AllPond.EastTransitPoolList[sbEastTransitPoolIndex].byModbusID, out bControlData, "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7") == true)
                            {
                                if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bClose_Machine(bControlData) == true)
                                {
                                    ModualAlarm.vSet_Modual_Alarm(AllPond.EastTransitPoolList[sbEastTransitPoolIndex].byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelControlError, true, 1, AllPond.EastTransitPoolList[sbEastTransitPoolIndex].strChannelNumber);
                                }
                            }
                        }
                    }
                    if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadRefControl == true && AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadOpenPumb == false)
                    {
                        if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].dChannelCurrent > CLOSECURRENT)
                        {
                            ModualAlarm.vSet_Modual_Alarm(AllPond.EastTransitPoolList[sbEastTransitPoolIndex].byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelControlError, true, 1, AllPond.EastTransitPoolList[sbEastTransitPoolIndex].strChannelNumber);
                        }
                    }
                    Thread.Sleep(200);
                }
                for (sbyte sbEastTransitPoolIndex = 0; sbEastTransitPoolIndex < AllPond.EastTransitPoolList.Count(); sbEastTransitPoolIndex++)
                {
                    if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadRefControl == true && AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadOpenPumb == true)
                    {
                        if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].dChannelCurrent < OPENCURRENT)
                        {
                            bool[] bControlData;
                            if (ModualPoll.bGet_channel_Value<bool>(AllPond.EastTransitPoolList[sbEastTransitPoolIndex].byModbusID, out bControlData, "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7") == true)
                            {
                                if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bClose_Machine(bControlData) == true)
                                {
                                    ModualAlarm.vSet_Modual_Alarm(AllPond.EastTransitPoolList[sbEastTransitPoolIndex].byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelControlError, true, 1, AllPond.EastTransitPoolList[sbEastTransitPoolIndex].strChannelNumber);
                                }
                            }
                        }
                    }
                    if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadRefControl == true && AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadOpenPumb == false)
                    {
                        if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].dChannelCurrent > CLOSECURRENT)
                        {
                            ModualAlarm.vSet_Modual_Alarm(AllPond.EastTransitPoolList[sbEastTransitPoolIndex].byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelControlError, true, 1, AllPond.EastTransitPoolList[sbEastTransitPoolIndex].strChannelNumber);
                        }
                    }
                    Thread.Sleep(200);
                }
                for (sbyte sbEastTransitPoolIndex = 0; sbEastTransitPoolIndex < AllPond.EastTransitPoolList.Count(); sbEastTransitPoolIndex++)
                {
                    if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadRefControl == true && AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadOpenPumb == true)
                    {
                        if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].dChannelCurrent < OPENCURRENT)
                        {
                            bool[] bControlData;
                            if (ModualPoll.bGet_channel_Value<bool>(AllPond.EastTransitPoolList[sbEastTransitPoolIndex].byModbusID, out bControlData, "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7") == true)
                            {
                                if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bClose_Machine(bControlData) == true)
                                {
                                    ModualAlarm.vSet_Modual_Alarm(AllPond.EastTransitPoolList[sbEastTransitPoolIndex].byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelControlError, true, 1, AllPond.EastTransitPoolList[sbEastTransitPoolIndex].strChannelNumber);
                                }
                            }
                        }
                    }
                    if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadRefControl == true && AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadOpenPumb == false)
                    {
                        if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].dChannelCurrent > CLOSECURRENT)
                        {
                            ModualAlarm.vSet_Modual_Alarm(AllPond.EastTransitPoolList[sbEastTransitPoolIndex].byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelControlError, true, 1, AllPond.EastTransitPoolList[sbEastTransitPoolIndex].strChannelNumber);
                        }
                    }
                    Thread.Sleep(200);
                }
                for (sbyte sbEastTransitPoolIndex = 0; sbEastTransitPoolIndex < AllPond.EastTransitPoolList.Count(); sbEastTransitPoolIndex++)
                {
                    if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadRefControl == true && AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadOpenPumb == true)
                    {
                        if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].dChannelCurrent < OPENCURRENT)
                        {
                            bool[] bControlData;
                            if (ModualPoll.bGet_channel_Value<bool>(AllPond.EastTransitPoolList[sbEastTransitPoolIndex].byModbusID, out bControlData, "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7") == true)
                            {
                                if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bClose_Machine(bControlData) == true)
                                {
                                    ModualAlarm.vSet_Modual_Alarm(AllPond.EastTransitPoolList[sbEastTransitPoolIndex].byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelControlError, true, 1, AllPond.EastTransitPoolList[sbEastTransitPoolIndex].strChannelNumber);
                                }
                            }
                        }
                    }
                    if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadRefControl == true && AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadOpenPumb == false)
                    {
                        if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].dChannelCurrent > CLOSECURRENT)
                        {
                            ModualAlarm.vSet_Modual_Alarm(AllPond.EastTransitPoolList[sbEastTransitPoolIndex].byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelControlError, true, 1, AllPond.EastTransitPoolList[sbEastTransitPoolIndex].strChannelNumber);
                        }
                    }

                }
                for (sbyte sbEastTransitPoolIndex = 0; sbEastTransitPoolIndex < AllPond.EastTransitPoolList.Count(); sbEastTransitPoolIndex++)
                {
                    if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadRefControl == true && AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadOpenPumb == true)
                    {
                        if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].dChannelCurrent < OPENCURRENT)
                        {
                            bool[] bControlData;
                            if (ModualPoll.bGet_channel_Value<bool>(AllPond.EastTransitPoolList[sbEastTransitPoolIndex].byModbusID, out bControlData, "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7") == true)
                            {
                                if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bClose_Machine(bControlData) == true)
                                {
                                    ModualAlarm.vSet_Modual_Alarm(AllPond.EastTransitPoolList[sbEastTransitPoolIndex].byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelControlError, true, 1, AllPond.EastTransitPoolList[sbEastTransitPoolIndex].strChannelNumber);
                                }
                            }
                        }
                    }
                    if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadRefControl == true && AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadOpenPumb == false)
                    {
                        if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].dChannelCurrent > CLOSECURRENT)
                        {
                            ModualAlarm.vSet_Modual_Alarm(AllPond.EastTransitPoolList[sbEastTransitPoolIndex].byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelControlError, true, 1, AllPond.EastTransitPoolList[sbEastTransitPoolIndex].strChannelNumber);
                        }
                    }

                }
                Thread.Sleep(1000);
            }
            
        }
        public static modual.eModualType eModdusId_Find_ModualType(string sModbusID)
        {
            for (int i = 0; i < ModualPoll.byX66cNumber; i++)
            {
                if (byte.Parse(sModbusID) == ModualPoll.cx66c.byModbusID[i])
                {
                    return modual.eModualType.WTDR66C;
                }
            }
            for (int i = 0; i < ModualPoll.byX18xNumber; i++)
            {
                if (byte.Parse(sModbusID) == ModualPoll.cx78c.byModbusID[i])
                {
                    return modual.eModualType.WTDR78C;
                }
            }

                    //if(cControlMap.chMap[i].srcType == "WTDR14P")
                    //    return modual.eModualType.WTDR14P;
                    //else if(cControlMap.chMap[i].srcType == "WTDR18X")
                    //    return modual.eModualType.WTDR18X;
                    //else if(cControlMap.chMap[i].srcType == "WTDR78C")
                    //    return modual.eModualType.WTDR78C;
                    //else if(cControlMap.chMap[i].srcType == "WTDR66C")
                    //    return modual.eModualType.WTDR66C;

            return modual.eModualType.IDLE;
        }
        public static bool bOperation_Machine(bool bOpenMachine, byte sbModbusID,bool[] bControlData,bool[] bControlBit,out bool bHadOpenMachine, byte byResModualID,string stResChannel)
        {
            bHadOpenMachine = true;
            bool bControlStatus = true;
            if (ModualPoll.bSet_All_Channel_Value(sbModbusID, bControlData) == true)
            {
                if (bOpenMachine == true && stResChannel != null)
                {
                    double[] dConvertData;
                    bHadOpenMachine = true;
                    Thread.Sleep(1000);
                    bControlStatus = ModualPoll.bGet_channel_Value<double>(byResModualID, out dConvertData, stResChannel);
                    if (dConvertData[0] > OPENCURRENT && bControlStatus == true)
                    {
                        bControlStatus = true;
                    }
                    else
                    {
                        bControlStatus = false;
                    }
                }
                else if (bOpenMachine == false && stResChannel != null)
                {
                    double[] dConvertData;
                    bHadOpenMachine = false;
                    Thread.Sleep(1000);
                    bControlStatus = ModualPoll.bGet_channel_Value<double>(byResModualID, out dConvertData, stResChannel);
                    if (dConvertData[0] < CLOSECURRENT && bControlStatus == true)
                    {
                        bControlStatus = true;
                    }
                    else
                    {
                        bControlStatus = false;
                    }
                }
                else
                {
                    bControlStatus = true;
                }
            }
            else
            {
                bControlStatus= false;
            }
            for (int i = 0; i < bControlBit.Count(); i++)
            {
                string str = "d" + i.ToString();
                if (bControlBit[i] == true)
                {
                    if (bControlStatus == true)
                        ModualAlarm.vSet_Modual_Alarm(sbModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelControlError, false, 1, str);
                    else
                        ModualAlarm.vSet_Modual_Alarm(sbModbusID,(ushort)ModualAlarm.eAlarmCode.ChannelControlError, true, 1, str);
                }
            }
            return bControlStatus;
        }
        public static void vDelete_Same_Control(ModualCntrol cModualCntrol)
        {
            for (sbyte i = 0; i < liModuualControl.Count; i++)
            {
                if (liModuualControl[i].sbModbusID == cModualCntrol.sbModbusID)
                {
                    if (Enumerable.SequenceEqual(liModuualControl[i].bControlBit, cModualCntrol.bControlBit))
                    {
                        liModuualControl.Remove(liModuualControl[i]);
                    }
                }
            }
        }
        public static void vPoolLevelParse(string stConfigString, out string stResponseStrign)
        {
            pcCfgRoot cCfgRoot = new pcCfgRoot();
            var jsonObj = new JObject();
            try
            {
                cCfgRoot = JsonConvert.DeserializeObject<pcCfgRoot>(stConfigString);
                jsonObj = JObject.Parse(stConfigString);
                for (int i = 0; i < cCfgRoot.ss.Count; i++)
                {
                    pcLiquidLevelConfig cLiquidLevelConfig = new pcLiquidLevelConfig
                    {
                        byModbusID = byte.Parse(cCfgRoot.ss[i].addr),
                        dUpLevel = double.Parse(cCfgRoot.ss[i].cfg.upper),
                        dDownLevel = double.Parse(cCfgRoot.ss[i].cfg.down)
                    };
                    string strChannelString = "d" + i.ToString();
                    for (int j = 0; j < 8; j++)
                    {
                        if (jsonObj["ss"][i]["cfg"].Value<string>("name") == strChannelString)
                        {
                            cLiquidLevelConfig.stChannelNumber = strChannelString;
                            jsonObj["ss"][i]["cfg"][strChannelString] = 1;
                            break;
                        }
                    }
             
                    if (jsonObj["ss"][i]["cfg"]["ts"] != null)
                    {
                        jsonObj["ss"][i]["cfg"]["ts"] = Form1.GetTimeStamp();
                    }
                    cPoolLevelConfig.Add(cLiquidLevelConfig);
                }
            }
            catch (Exception exception)
            {
                Form1.totxt.Log(exception + "Cfg Mqtt Parse Fail");
                stResponseStrign = "";
            }
            finally
            {
                stResponseStrign = jsonObj.ToString();
            }
        }
    }
}