﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ModbusDemo.windows;
using ModbusDemo;
using ModbusDemo.MessageFormat;
using ModbusDemo.Modular;
namespace ModbusDemo.application
{
    public class ModualPool
    {
        public class pcTemperature
        {
            private string      strTemperName;
            public double       dCurrentTemperate { get => vGet_ResCurrent();}
            private byte        byModbusID;
            private string[]    strChannelNumber;
            public pcTemperature(string strName,byte byModbusID, params string[] strChannelNumber)
            {
                this.strTemperName    = strName;
                this.byModbusID       = byModbusID;
                this.strChannelNumber = strChannelNumber;
            }
            private double vGet_ResCurrent()
            {
                double[] dConvertData;
                double resData = 0;
                if (ModualPoll.bGet_channel_Value<double>(byModbusID, out dConvertData, strChannelNumber) == true)
                {
                    List<double> ConvertData = new List<double>();
                    for (int i = 0; i < dConvertData.Count(); i++)
                    {
                        if (dConvertData[i] > 0 && dConvertData[i] < 80)
                        {
                            ConvertData.Add(dConvertData[i]);
                        }
                    }
                    for (int i = 0; i < ConvertData.Count(); i++)
                    {
                         resData+= ConvertData[i];
                    }
                     return resData/ConvertData.Count();
                }
                return 0;
            }
        }
        public class pcLiquidlevel
        {
            private string   strLevel;
            public double    dCurrentlevel { get => vGet_ResCurrent();}
            private byte     byModbusID;
            private string[] strChannelNumber;
            public pcLiquidlevel(string strName, byte byModbusID,params string[] strChannelNumber)
            {
                this.strLevel           = strName;
                this.byModbusID         = byModbusID;
                this.strChannelNumber   = strChannelNumber;
            }
            private double vGet_ResCurrent()
            {
                double[] dConvertData;
                double resData = 0;
                if (ModualPoll.bGet_channel_Value<double>(byModbusID, out dConvertData, strChannelNumber) == true)
                {
                    List<double> ConvertData = new List<double>();
                    for (int i = 0; i < dConvertData.Count(); i++)
                    {
                        if (dConvertData[i] > 0 && dConvertData[i] < 5)
                        {
                            ConvertData.Add(dConvertData[i]);
                        }
                    }
                    for (int i = 0; i < ConvertData.Count(); i++)
                    {
                        resData += ConvertData[i];
                    }
                    return resData / ConvertData.Count();
                }
                return 0;
            }
        }
        public class pcOperation
        {
            public byte         byModbusID;
            public string[]     strChannelNumber;
            public string       strOperationNumber;
            public bool[]       bOpenOperation;
            public bool[]       bCloseOperation;

            public bool         bHadRefControl;
            public byte         byResModbusID;
            public string       strResChannelNumber;
        }
        public class pcMachine : pcOperation
        {
            public string strMachinebName;
            public double dChannelCurrent { get => vGet_ResCurrent();}
            public bool   bHadOpenPumb;
            public bool[] bCurrentRelay   { get => bGet_Current_Relay();}
            public pcMachine(string strMachineName,pcOperation pcOperation) // base(pcOperation.byModbusID,pcOperation.strChannelNumber,pcOperation.strOperationNumber,pcOperation.bHadRefControl,pcOperation.byResModbusID,pcOperation.strResChannelNumber,pcOperation.bOpenOperation,pcOperation.bCloseOperation)
            {
                this.strMachinebName     = strMachineName;
                this.byModbusID          = pcOperation.byModbusID;
                this.strChannelNumber    = pcOperation.strChannelNumber;
                this.strOperationNumber  = pcOperation.strOperationNumber;
                this.bHadRefControl      = pcOperation.bHadRefControl;
                this.byResModbusID       = pcOperation.byResModbusID;
                this.strResChannelNumber = pcOperation.strResChannelNumber;
                this.bOpenOperation      = pcOperation.bOpenOperation;
                this.bCloseOperation     = pcOperation.bCloseOperation;
            }
            public bool bOpen_Machine(bool[] bControldata)
            {
                bool[] bControlBit = new bool[bControldata.Count()];
                bool bStatus;
                for (int i = 0; i < bControldata.Count(); i++)
                {
                    string str= "d"+i.ToString();
                    for (int j = 0; j < strChannelNumber.Count(); j++)
                    {
                        if (str == strChannelNumber[j])
                        {
                            bControlBit[i] = true;
                            bControldata[i] = bOpenOperation[j];
                        }
                    }
                }
                if ((bStatus = ModualControl.bOperation_Machine(true, byModbusID, bControldata, bControlBit,out bHadOpenPumb, byResModbusID, strResChannelNumber)) == true)
                { 
                    bHadOpenPumb = true;
                }
                return bStatus;
            }
            public bool bClose_Machine(bool[] bControldata)
            {
                bool[] bControlBit = new bool[bControldata.Count()];
                bool bStatus;
                for (int i = 0; i < bControldata.Count(); i++)
                {
                    string str = "d" + i.ToString();
                    for (int j = 0; j < strChannelNumber.Count(); j++)
                    {
                        if (str == strChannelNumber[j])
                        {
                            bControlBit[i] = true;
                            bControldata[i] = bCloseOperation[j];
                        }
                    }
                }
                if ((bStatus = ModualControl.bOperation_Machine(false, byModbusID, bControldata, bControlBit,out bHadOpenPumb, byResModbusID, strResChannelNumber)) == true)
                { 
                     bHadOpenPumb = false;
                }
               return bStatus;
            }
            private double vGet_ResCurrent()
            {
                double[] dConvertData;
                if (bHadRefControl == true && ModualPoll.bGet_channel_Value<double>(byResModbusID, out dConvertData, strResChannelNumber) == true)
                {
                    return dConvertData[0];
                }
                return 0;
            }
            private bool[] bGet_Current_Relay()
            { 
                bool[] bRelaydata;
                if (ModualPoll.bGet_channel_Value<bool>(byModbusID, out bRelaydata, strChannelNumber) == true)
                {
                    return bRelaydata;
                }
                else
                {
                    return bRelaydata;
                }
            }
        }
        public class pcButtonOperation
        {
            public byte byModbusID;
            public string[] strChannelNumber;
            public string strOperationNumber;
            public bool[] bOpenOperation;
            public bool[] bCloseOperation;
        }
        public class pcButton :pcButtonOperation
        {
            public string       strButtonName;
            public bool[]       bCurrentRelay   { get => bGet_Current_Relay();}
            public pcButton(string strButtonName,pcButtonOperation cButtonOperation)
            {
                this.strButtonName        = strButtonName;
                this.byModbusID           = cButtonOperation.byModbusID;
                this.strOperationNumber   = cButtonOperation.strOperationNumber;
                this.strChannelNumber     = cButtonOperation.strChannelNumber;  
                this.bOpenOperation       = cButtonOperation.bOpenOperation;
                this.bCloseOperation      = cButtonOperation.bCloseOperation;
            }
            public bool bOpreation_Button(bool[] bControldata)
            { 
                bool bStatus;
                bool bHadOpenButton;
                bool[] bControlBit = new bool[bControldata.Count()];
                for (int i = 0; i < bControldata.Count(); i++)
                {
                    string str = "d" + i.ToString();
                    for (int j = 0; j < strChannelNumber.Count(); j++)
                    {
                        if (str == strChannelNumber[j])
                        {
                            bControlBit[i] = true;
                            bControldata[i] = bOpenOperation[j];
                        }
                    }
                }
                if ((bStatus = ModualControl.bOperation_Machine(true, byModbusID, bControldata, bControlBit,out bHadOpenButton, 0, null)) == true)
                {
                    for (int i = 0; i < bControldata.Count(); i++)
                    {
                        string str = "d" + i.ToString();
                        for (int j = 0; j < strChannelNumber.Count(); j++)
                        {
                            if (str == strChannelNumber[j])
                            {
                                bControlBit[i] = true;
                                bControldata[i] = bCloseOperation[j];
                            }
                        }
                    }
                    bStatus = ModualControl.bOperation_Machine(true, byModbusID, bControldata, bControlBit, out bHadOpenButton,0, null);
                }
                return bStatus;
                
            }
            private bool[] bGet_Current_Relay()
            {
                bool[] bRelaydata;
                if (ModualPoll.bGet_channel_Value<bool>(byModbusID, out bRelaydata, strChannelNumber) == true)
                {
                    return bRelaydata;
                }
                else
                {
                    return bRelaydata;
                }
            }
        }
    }
}
