﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO.Ports;
using System.Linq;
using System.Net.NetworkInformation;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using Modbus.Device;
using MQTTnet;
using MQTTnet.Client;
using Newtonsoft.Json;
using System.IO;
using System.Diagnostics;
using ModbusDemo;
using System.Timers;
using ModbusDemo.application;
using System.Collections;
using ModbusDemo.Modular;
using ModbusDemo.MessageFormat;
namespace ModbusDemo
{
    public partial class Form1 : Form
    {
        const bool LOCALDEBUG = false;
        private bool bStart = false;
        AutoResetEvent exitEvent;
        private int waitTime;
        private Thread t_UpgradeConn;
        private Thread t_AutoControl;

        public delegate void invokeDelegate();
        System.Timers.Timer MQTTTimer = new System.Timers.Timer();
        BackgroundWorker m_bgw0 = new BackgroundWorker();
        bool m_Isbgw0_CanContinueRun = true;
        bool bCretaThead = false;
        public static ModbusDemo.windows.Totxt totxt = new windows.Totxt(AppDomain.CurrentDomain.BaseDirectory + @"/log/Log.txt");

        public Form1()
        {
            InitializeComponent();
            m_bgw0.WorkerSupportsCancellation = false;
            m_bgw0.DoWork += m_bgw0_DoWork;
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            cmbBaud.SelectedIndex = 7;
            cmbDataBit.SelectedIndex = 1;
            cmbParity.SelectedIndex = 0;
            cmbStopBit.SelectedIndex = 0;
            foreach (string s in SerialPort.GetPortNames())
                cmbPort.Items.Add(s);
            cmbPort.SelectedIndex = -1;

            exitEvent = new AutoResetEvent(false);
            waitTime = 6000;
            t_UpgradeConn = new Thread(UpgradeProc);
            t_UpgradeConn.IsBackground = true;
            t_UpgradeConn.Start();
            run();
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            System.Environment.Exit(0);
        }

        private SerialPort comPort = new SerialPort();
        public static ModbusMaster master;

        private MethodInvoker MQTT_thread;
        private 
        string mqttIp;
        string mqttClientId;
        int mqttPort;
        string mqttUsername;
        string mqttPwd;

        public const string mqttSn                    = "66666666";
        public const string mqttSubscribeControlTopic = "Witium/WTDS78X/" + mqttSn + "/Ctrl";
        public const string mqttBackTopic             = "Witium/WTDS78X/" + mqttSn + "/Back";
        public const string mqttCfgTopic              = "Witium/WTDS78X/" + mqttSn + "/Config";
        public const string mqttCfgResTopic           = "Witium/WTDS78X/" + mqttSn + "/CfgRes";
        public const string mqttTopic                 = "Witium/WTDS78X/" + mqttSn + "/Data";
        public const string sAlarmTopic               = "Witium/WTDS78X/" + mqttSn + "/Alarm";
        string mqttData;//数据
        string mqttData_Back;//数据
        private IMqttClient mqttClient = null;
        private bool isReconnect = true;
        private void SetMqtt()
        {
            if (LOCALDEBUG == true)
            {
                mqttIp = "47.101.50.24";
                mqttClientId = GetTimeStamp() + "sxz";
                mqttPort = 1883;
                mqttUsername = "root";
                mqttPwd = "public";
            }
            else
            {
                mqttIp = "172.16.1.24";//"120.27.235.39"
                mqttClientId = GetTimeStamp() + "sxz";
                mqttPort = 1883;
                mqttUsername = "pasture";
                mqttPwd = "Pasture37774020";
            }
        }
        void m_bgw0_DoWork(object sender, DoWorkEventArgs e)
        {
            while (m_Isbgw0_CanContinueRun)
            {
                int _n = 2;
                this.Invoke(new Action(() =>
                {
                }));
                Thread.Sleep(1000);
            }
        }
        #region 时间戳
        /// <summary> 
        /// 获取时间戳 
        /// </summary> 
        /// <returns></returns> 
        public static UInt64 GetTimeStamp()
        {
            TimeSpan ts = DateTime.UtcNow - new DateTime(1970, 1, 1, 0, 0, 0, 0);
            return Convert.ToUInt64(ts.TotalSeconds);

        }
        #endregion

        #region mqtt服务
        //创建一个委托，是为访问TextBox控件服务的。
        public delegate void UpdateTxt(string msg);
        //定义一个委托变量
        public UpdateTxt updateTxt;
        private Thread ModbusControlThread;
        private Thread MqttReceiveThread;
        public List<string> ListHandle = new List<string>();
        private async Task Publish()
        {
            var message = new MqttApplicationMessageBuilder()
                .WithTopic(mqttTopic)
                .WithPayload(mqttData)
                .WithAtMostOnceQoS()
                .WithRetainFlag(false)
                .Build();
            if (mqttData != null)
            {
                await mqttClient.PublishAsync(message);
            }
        }
        private  void vControlResponseBack()
        {
            var message = new MqttApplicationMessageBuilder()
                  .WithTopic(mqttBackTopic)
                  .WithPayload(mqttData_Back)
                  .WithAtLeastOnceQoS()
                  .WithRetainFlag(false)
                  .Build();
             mqttClient.PublishAsync(message);
        }

        private async Task vCfgResponseBack(string data)
        {
            var message = new MqttApplicationMessageBuilder()
                  .WithTopic(mqttCfgResTopic)
                  .WithPayload(data)
                  .WithAtMostOnceQoS()
                  .WithRetainFlag(false)
                  .Build();
            await mqttClient.PublishAsync(message);
        }
        private async Task Subscribe()
        {
            if (!mqttClient.IsConnected)
            {
                MessageBox.Show("MQTT客户端尚未连接！");
                return;
            }

            // Subscribe to a topic
            await mqttClient.SubscribeAsync(new TopicFilterBuilder()
                .WithTopic(mqttSubscribeControlTopic)
                .WithAtMostOnceQoS()
                .Build()
                );

            await mqttClient.SubscribeAsync(new TopicFilterBuilder()
                  .WithTopic(mqttCfgTopic)
                  .WithAtMostOnceQoS()
                  .Build()
                  );
            Invoke((new Action(() =>
            {
                Console.WriteLine("已订阅[{topic}]主题{Environment.NewLine}");

                txtReceiveMessage.AppendText($"已订阅[{mqttSubscribeControlTopic}]主题{Environment.NewLine}");
                txtReceiveMessage.AppendText($"已订阅[{mqttCfgTopic}]主题{Environment.NewLine}");
            })));
        }
        //private async Task ConnectMqttServerAsync()
        private async Task ConnectMqttServerAsync()
        {
            // Create a new MQTT client.
            if (mqttClient == null)
            {
                var factory = new MqttFactory();
                mqttClient = factory.CreateMqttClient();
                mqttClient.ApplicationMessageReceived += MqttClient_ApplicationMessageReceived;
                mqttClient.Connected += MqttClient_Connected;
                mqttClient.Disconnected += MqttClient_Disconnected;
            }

            //非托管客户端
            try
            {

                //Create TCP based options using the builder.
                var options = new MqttClientOptionsBuilder()
                    .WithClientId(mqttClientId)
                    .WithTcpServer(mqttIp, mqttPort)
                    .WithCredentials(mqttUsername, mqttPwd)

                    //.WithTls()//服务器端没有启用加密协议，这里用tls的会提示协议异常
                    .WithCleanSession()
                    .Build();

                await mqttClient.ConnectAsync(options);
            }
            catch (Exception ex)
            {
                Invoke((new Action(() =>
                {
                    //txtReceiveMessage.AppendText($"连接到MQTT服务器失败！" + Environment.NewLine + ex.Message + Environment.NewLine);
                    Console.WriteLine($"连接到MQTT服务器失败！" + Environment.NewLine + ex.Message + Environment.NewLine);
                    //totxt.Log($"连接到MQTT服务器失败！" + Environment.NewLine + ex.Message + Environment.NewLine);
                })));
            }

            //托管客户端
            try
            {

            }
            catch (Exception)
            {

            }
        }
        private void MqttClient_Connected(object sender, EventArgs e)
        {
            Invoke((new Action(() =>
            {
                //txtReceiveMessage.Clear();
                txtReceiveMessage.AppendText("已连接到MQTT服务器！" + Environment.NewLine);
                //totxt.Log("已连接到MQTT服务器！" + Environment.NewLine);
                //Console.WriteLine("已连接到MQTT服务器！" + Environment.NewLine);
            })));
        }
        private void MqttClient_Disconnected(object sender, EventArgs e)
        {
            Invoke((new Action(() =>
            {
                txtReceiveMessage.Clear();
                DateTime curTime = new DateTime();
                curTime = DateTime.UtcNow;
                txtReceiveMessage.AppendText($">> [{curTime.ToLongTimeString()}]");
                //totxt.Log($">> [{curTime.ToLongTimeString()}]");
                txtReceiveMessage.AppendText("已断开MQTT连接！" + Environment.NewLine);
                //totxt.Log("已断开MQTT连接！" + Environment.NewLine);

                //Console.WriteLine("已断开MQTT连接！" + Environment.NewLine);
            })));

            //Reconnecting
            if (isReconnect)
            {
                Invoke((new Action(() =>
                {
                    txtReceiveMessage.AppendText("正在尝试重新连接" + Environment.NewLine);
                    totxt.Log("正在尝试重新连接" + Environment.NewLine);

                    //Console.WriteLine("正在尝试重新连接" + Environment.NewLine);

                })));

                var options = new MqttClientOptionsBuilder()
                    .WithClientId(mqttClientId)
                    .WithTcpServer(mqttIp, mqttPort)
                    .WithCredentials(mqttUsername, mqttPwd)
                    //.WithTls()
                    .WithCleanSession()
                    .Build();
                Invoke((new Action(async () =>
                {
                    await Task.Delay(TimeSpan.FromSeconds(5));
                    try
                    {
                        await mqttClient.ConnectAsync(options);
                    }
                    catch
                    {
                        txtReceiveMessage.AppendText("### RECONNECTING FAILED ###" + Environment.NewLine);
                        //totxt.Log("### RECONNECTING FAILED ###" + Environment.NewLine);
                        //Console.WriteLine("### RECONNECTING FAILED ###" + Environment.NewLine);
                    }
                })));
            }
            else
            {
                Invoke((new Action(() =>
                {
                    txtReceiveMessage.AppendText("已下线！" + Environment.NewLine);
                    totxt.Log("已下线！" + Environment.NewLine);
                    //Console.WriteLine("已下线！" + Environment.NewLine);
                })));
            }
        }
        private void MqttClient_ApplicationMessageReceived(object sender, MqttApplicationMessageReceivedEventArgs e)
        {
            Invoke((new Action(() =>
            {
                //收到的消息啦
                txtReceiveMessage.AppendText($">> {"### RECEIVED APPLICATION MESSAGE ###"}{Environment.NewLine}");
                totxt.Log($">> {"### RECEIVED APPLICATION MESSAGE ###"}{Environment.NewLine}");
                txtReceiveMessage.AppendText($">> Topic = {e.ApplicationMessage.Topic}{Environment.NewLine}");
                totxt.Log($">> Topic = {e.ApplicationMessage.Topic}{Environment.NewLine}");
                txtReceiveMessage.AppendText($">> QoS = {e.ApplicationMessage.QualityOfServiceLevel}{Environment.NewLine}");
                txtReceiveMessage.AppendText($">> Retain = {e.ApplicationMessage.Retain}{Environment.NewLine}");

            })));
            Invoke((new Action(async () =>
            {
                string stConvertString;
                //消息的内容
                txtReceiveMessage.AppendText($">> Payload = {Encoding.UTF8.GetString(e.ApplicationMessage.Payload)}{Environment.NewLine}");
                totxt.Log($">> Payload = {Encoding.UTF8.GetString(e.ApplicationMessage.Payload)}{Environment.NewLine}");
                stConvertString = Encoding.UTF8.GetString(e.ApplicationMessage.Payload);
                Console.WriteLine(stConvertString);
                if (e.ApplicationMessage.Topic == mqttSubscribeControlTopic)
                {
                    ListHandle.Add(stConvertString);
                }
                else if (e.ApplicationMessage.Topic == mqttCfgTopic)
                {
                    ModualControl.vPoolLevelParse(stConvertString, out mqttData_Back);
                    await vCfgResponseBack(mqttData_Back);
                }
            })));
        }

        private  void  vMqtt_Receive_Handle()
        {
            while (true)
            {
                for (int i = 0; i < ListHandle.Count; i++)
                {
                    ModualControl.vGetaWay_Receive_Control(ListHandle[i], out mqttData_Back);
                    vControlResponseBack();
                    ListHandle.Remove(ListHandle[i]);
                }
               Thread.Sleep(100);
            }  
        }
        #endregion

        #region modbus线程
         
        private static bool bSetDataIsRunning = false;

        private Thread ModbusPollThread;
        private void vModbusPoll()
        {
            while (true)
            {
                bSetDataIsRunning = true;
                ModualPoll.vAllNodePoll();
                mqttData = ModualPoll.stAll_Poll_Package();
                ModualPoll.vCheckAlarm_And_Send(mqttClient);
                label5.Text = ModbusComm.usCommunFailTimes.ToString();
            }
        }
        private void Sendout()
        {
            Control.CheckForIllegalCrossThreadCalls = false;
            MQTTTimer.Interval = 20000;//120500
            MQTTTimer.Enabled = true;
            MQTTTimer.AutoReset = true;//设置是执行一次（false）还是一直执行(true)；  
            MQTTTimer.Start();
            MQTTTimer.Elapsed += async (o, a) =>
            {
                try
                {
                    await Publish();
                }
                catch (Exception ex)
                {
                    totxt.Log(ex + "," + Environment.NewLine + "\n");
                    return;
                }
            };
        }

        //声明委托
        private delegate void SetDataDelegate();
        private async void SetData()
        {
            if (this.InvokeRequired)
            {
                this.Invoke(new SetDataDelegate(SetData));
            }
            else
            {
                if (bSetDataIsRunning == false)
                {
                    bSetDataIsRunning = true;
                    await Task.Run(() =>
                    {
                        totxt.Log("开始执行");
                        ModualPoll.vAllNodePoll();
                        mqttData = ModualPoll.stAll_Poll_Package();
                        ModualPoll.vCheckAlarm_And_Send(mqttClient);
                        totxt.Log("执行结束");
                    });
                    bSetDataIsRunning = false;
                }
            }
        }
        //声明委托
        private delegate void ShowMessageDelegate(string message);
        private void ShowMessage(string message)
        {
            if (this.InvokeRequired)
            {
                ShowMessageDelegate showMessageDelegate = ShowMessage;
                this.Invoke(showMessageDelegate, new object[] { message });
            }
            else
            {
                totxt.Log(message);
            }
        }
        #endregion

        #region json字符串转对象
        /// <summary>
        /// json字符串转对象
        /// </summary>
        /// <typeparam name="RData">接收的对象</typeparam>
        /// <param name="rd">json字符串</param>
        /// <returns></returns>
        public RData DataConversion<RData>(string rd)
        {
            try
            {
                return JsonConvert.DeserializeObject<RData>(rd);
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
                return default(RData);
            }
        }
        public UData DataConverion<UData>(string ud)
        {
            try
            {
                return JsonConvert.DeserializeObject<UData>(ud);
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
                return default(UData);
            }
        }
        /// <summary>
        /// 对象转json字符串
        /// </summary>
        /// <param name="ud">上传实体</param>
        /// <returns></returns>
        public string DataConversion(UData ud)
        {
            try
            {
                return JsonConvert.SerializeObject(ud);
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
                return "";
            }
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="rD"></param>
        /// <returns></returns>
        public string DataConversion(RData rD)
        {
            try
            {
                return JsonConvert.SerializeObject(rD);
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
                return "";
            }
        }
        #endregion

        #region 网络检测

        ManualResetEvent network = new ManualResetEvent(false);
        Thread MonitorThread;
        private void StartMonitorThread()
        {
            if (network != null)
            {
                network.Reset();
            }
            MonitorThread = new Thread(MonitorNetWork);
            MonitorThread.IsBackground = true;
            MonitorThread.Start();
        }
        public void MonitorThreadStop()
        {
            network.Set();
        }
        private void MonitorNetWork()
        {
            while (!network.WaitOne(500))
            {
                string url = "www.baidu.com;www.sina.com;www.cnblogs.com;www.google.com;www.163.com;www.csdn.com";
                string[] urls = url.Split(new char[] { ';' });
                CheckServeStatus(urls);
                Thread.Sleep(1000);
            }
        }
        /// <summary>
        /// 检测网络连接状态
        /// </summary>
        /// <param name="urls"></param>
        public static void CheckServeStatus(string[] urls)
        {
            int errCount = 0;//ping时连接失败个数

            if (!LocalConnectionStatus())
            {
                Console.WriteLine("网络异常~无连接");
            }
            else if (!MyPing(urls, out errCount))
            {
                if ((double)errCount / urls.Length >= 0.3)
                {
                    Console.WriteLine("网络异常~连接多次无响应");
                }
                else
                {
                    Console.WriteLine("网络不稳定");
                }
            }
            else
            {
                Console.WriteLine("网络正常");
            }
        }

        private const int INTERNET_CONNECTION_MODEM = 1;
        private const int INTERNET_CONNECTION_LAN = 2;

        [System.Runtime.InteropServices.DllImport("winInet.dll")]
        private static extern bool InternetGetConnectedState(ref int dwFlag, int dwReserved);

        /// <summary>
        /// 判断本地的连接状态
        /// </summary>
        /// <returns></returns>
        private static bool LocalConnectionStatus()
        {
            System.Int32 dwFlag = new Int32();
            if (!InternetGetConnectedState(ref dwFlag, 0))
            {
                Console.WriteLine("LocalConnectionStatus--未连网!");
                return false;
            }
            else
            {
                if ((dwFlag & INTERNET_CONNECTION_MODEM) != 0)
                {
                    Console.WriteLine("LocalConnectionStatus--采用调制解调器上网。");
                    return true;
                }
                else if ((dwFlag & INTERNET_CONNECTION_LAN) != 0)
                {
                    Console.WriteLine("LocalConnectionStatus--采用网卡上网。");
                    return true;
                }
            }
            return false;
        }

        /// <summary>
        /// Ping命令检测网络是否畅通
        /// </summary>
        /// <param name="urls">URL数据</param>
        /// <param name="errorCount">ping时连接失败个数</param>
        /// <returns></returns>
        public static bool MyPing(string[] urls, out int errorCount)
        {
            bool isconn = true;
            Ping ping = new Ping();
            errorCount = 0;
            try
            {
                PingReply pr;
                for (int i = 0; i < urls.Length; i++)
                {
                    pr = ping.Send(urls[i]);
                    if (pr.Status != IPStatus.Success)
                    {
                        isconn = false;
                        errorCount++;
                    }
                    Console.WriteLine("Ping " + urls[i] + "    " + pr.Status.ToString());
                }
            }
            catch
            {
                isconn = false;
                errorCount = urls.Length;
            }
            //if (errorCount > 0 && errorCount < 3)
            //  isconn = true;
            return isconn;
        }
        #endregion

        #region 更新线程
        string ImagefilePath = null;
        private void bgWorker_DoWork(object sender, DoWorkEventArgs e)
        {
            this.upgrade();
        }
        private void bgWorker_ProgressChanged(object sender, ProgressChangedEventArgs e)
        {
            UpdateBar.Value = e.ProgressPercentage;
        }
        private void choosebth_Click(object sender, EventArgs e)
        {
            OpenFileDialog dialog = new OpenFileDialog();
            dialog.Multiselect = false;//该值确定是否可以选择多个文件
            dialog.Title = "请选择文件夹";
            dialog.Filter = "镜像文件(*.bin)|*.bin";
            if (dialog.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                string file = dialog.FileName;
                this.ImagefilePath = file;
                if (file.Substring(file.LastIndexOf("\\") + 1).Length > 20)
                {
                    string str = ((file.Substring(file.LastIndexOf("\\") + 1)).Substring(0, 10));
                    this.imagesname.Text = str + "******";
                }
                else
                    this.imagesname.Text = file.Substring(file.LastIndexOf("\\") + 1);


            }
        }
        private void UpdateBtn_Click(object sender, EventArgs e)
        {
            bStart = true;
            int iMaxBufSize = 1024 * 100;
            this.UpdateBtn.Enabled = false;
            this.choosebth.Enabled = false;
            int iFileSize = 0;
            Byte[] FileBuf = new Byte[iMaxBufSize];

            if (ImagefilePath != null)
            {
                FileStream fsl = File.Open(ImagefilePath, FileMode.Open, FileAccess.ReadWrite);
                if (File.Exists(ImagefilePath) == true)
                {
                    BinaryReader br = new BinaryReader(fsl);

                    FileBuf = br.ReadBytes(iMaxBufSize);

                    iFileSize = FileBuf.Length;

                    br.Close();
                    fsl.Close();
                }
            }
            else
            {
                MessageBox.Show("程序不存在");
                this.UpdateBtn.Enabled = true;
                this.choosebth.Enabled = true;
            }

            UpdateBar.Maximum = iFileSize;
            UpdateBar.Minimum = 0;


            if (bStart == true)
            {
                this.bgWorker.WorkerReportsProgress = true;
                this.bgWorker.RunWorkerAsync();
                bStart = false;
            }
            else
            {
                this.bgWorker.WorkerReportsProgress = false;
            }
        }
        private void UpgradeProc()
        {
            while (true)
            {
                if (exitEvent.WaitOne(waitTime))
                {
                    break;
                }
                invokeDelegate setText = () =>
                {
                    if (this.UpdateBar.Value == this.UpdateBar.Maximum)
                    {
                        MessageBox.Show("更新成功！");
                        this.UpdateBar.Value = this.UpdateBar.Minimum;
                        this.UpdateBtn.Enabled = false;
                        this.choosebth.Enabled = true;
                    }
                };
                Invoke(setText);
            }
        }
        private void upgrade()
        {
            //CheckForIllegalCrossThreadCalls = false;
            ////设置CheckForIllegalCrossThreadCalls = false 是能去掉这个检查的,但是这不是标准的作法.
            ////标准的作法是在访问界面控件时,访问下窗体的 InvokeRequired 属性,如果为false就可以直接访问,
            ////否则就是跨线程访问; 此时,创建一个delegate,并通过Invoke() 来调用它.
            ////参考https://www.cnblogs.com/janghe/p/7874889.html

            const int Singlepackage = 100;
            const int PerBlockPacket = Singlepackage;
            int iFileSizeNow = 0;
            int iFileSize = 0;
            int iMaxBufSize = 1024 * 100;
            ushort[] istage = new ushort[2];
            //ushort[] data = new ushort[2];

            Byte[] FileBuf = new Byte[iMaxBufSize];
            string strLog = "";
            UInt16 u16DevStatus = 0;
            ushort[] usTrans = new ushort[Singlepackage];

            UInt16[] u16unlock = { 0x5749, 0x5449, 0x554D };
            int errCnt = 0;

            FileStream fsl = File.Open(ImagefilePath, FileMode.Open, FileAccess.ReadWrite);
            if (File.Exists(ImagefilePath) == true)
            {
                BinaryReader br = new BinaryReader(fsl);

                FileBuf = br.ReadBytes(iMaxBufSize);

                iFileSize = FileBuf.Length;

                br.Close();
                fsl.Close();
            }
            else
            {
                MessageBox.Show("程序不存在");
            }



            istage[0] = 0;

            master.WriteSingleRegister(1, 20600, 0);

            ushort[] usFileBuf = new ushort[iMaxBufSize];
            Buffer.BlockCopy(FileBuf, 0, usFileBuf, 0, FileBuf.Length);
            bgWorker.ReportProgress(0);
            while (true)
            {
                try
                {
                    ushort[] data = master.ReadHoldingRegisters(1, 20600, 1);
                    u16DevStatus = data[0];
                    int sent = istage[0] * (Singlepackage * 2);

                    strLog = sent.ToString() + " has been sent.";
                    // UpdateBar.Value = sent;
                    bgWorker.ReportProgress(sent);

                    if (u16DevStatus == istage[0])
                    {

                    }
                    else
                    {
                        continue;
                    }

                    if (iFileSizeNow + PerBlockPacket * 2 <= iFileSize)
                    {
                        Buffer.BlockCopy(usFileBuf, iFileSizeNow, usTrans, 0, Singlepackage * 2);
                        try
                        {
                            master.WriteMultipleRegisters(1, 20480, usTrans);
                            istage[0]++;
                            iFileSizeNow += PerBlockPacket * 2;
                            //Thread.Sleep(10);
                        }
                        catch (Exception exception)
                        {
                            //Connection exception
                            //No response from server.
                            //The server maybe close the com port, or response timeout.
                            if (exception.Source.Equals("System"))
                            {
                                if (errCnt > 5)
                                    return;
                                else
                                    errCnt++;

                                Console.WriteLine(DateTime.Now.ToString() + " " + exception.Message);
                                MessageBox.Show(DateTime.Now.ToString() + " " + exception.Message);
                                this.UpdateBar.Value = this.UpdateBar.Minimum;
                                //this.StartTest.Enabled = false;
                                //this.reset.Enabled = false;
                                this.UpdateBtn.Enabled = false;
                                this.choosebth.Enabled = false;
                                return;
                            }
                        }

                    }
                    else
                    {
                        //最后一帧
                        Array.Clear(usTrans, 0, usTrans.Length);
                        Buffer.BlockCopy(usFileBuf, iFileSizeNow, usTrans, 0, iFileSize - iFileSizeNow);
                        try
                        {
                            master.WriteMultipleRegisters(1, 20480, usTrans);
                            istage[0]++;
                            iFileSizeNow += PerBlockPacket * 2;
                            istage[0] = 0x5754;
                            bgWorker.ReportProgress(iFileSize);
                            while (true)
                            {
                                //ret = mb_dev.WriteMultipleRegs(wtdslaveid, 2173, 3, "", 502, ref u16unlock);
                                try
                                {
                                    master.WriteMultipleRegisters(1, 20601, u16unlock);
                                    break;
                                }
                                catch (Exception exception)
                                {
                                    //Connection exception
                                    //No response from server.
                                    //The server maybe close the com port, or response timeout.
                                    if (exception.Source.Equals("System"))
                                    {
                                        Console.WriteLine(DateTime.Now.ToString() + " " + exception.Message);
                                        MessageBox.Show(DateTime.Now.ToString() + " " + exception.Message);
                                        this.UpdateBar.Value = this.UpdateBar.Minimum;
                                        //this.StartTest.Enabled = false;
                                        //this.reset.Enabled = false;
                                        this.UpdateBtn.Enabled = false;
                                        this.choosebth.Enabled = false;
                                        return;
                                    }
                                }

                            }
                            return;
                        }
                        catch (Exception exception)
                        {
                            //Connection exception
                            //No response from server.
                            //The server maybe close the com port, or response timeout.
                            if (exception.Source.Equals("System"))
                            {
                                if (errCnt > 5)
                                    return;
                                else
                                    errCnt++;

                                Console.WriteLine(DateTime.Now.ToString() + " " + exception.Message);
                                //MessageBox.Show(DateTime.Now.ToString() + " " + exception.Message);
                                this.UpdateBar.Value = this.UpdateBar.Minimum;
                                //this.StartTest.Enabled = false;
                                //this.reset.Enabled = false;
                                this.UpdateBtn.Enabled = false;
                                this.choosebth.Enabled = false;
                                return;
                            }
                        }
                    }

                }
                catch (Exception exception)
                {
                    //Connection exception
                    //No response from server.
                    //The server maybe close the com port, or response timeout.
                    if (exception.Source.Equals("System"))
                    {
                        if (errCnt > 5)
                            return;
                        else
                            errCnt++;

                        Console.WriteLine(DateTime.Now.ToString() + " " + exception.Message);
                        MessageBox.Show(DateTime.Now.ToString() + " " + exception.Message);
                        this.UpdateBar.Value = this.UpdateBar.Minimum;
                        //this.StartTest.Enabled = false;
                        //this.reset.Enabled = false;
                        this.UpdateBtn.Enabled = false;
                        this.choosebth.Enabled = false;
                        return;
                    }
                    //The server return error code.
                    //You can get the function code and exception code.
                    if (exception.Source.Equals("nModbusPC"))
                    {
                        string str = exception.Message;
                        int FunctionCode;
                        string ExceptionCode;

                        str = str.Remove(0, str.IndexOf("\r\n") + 17);
                        FunctionCode = Convert.ToInt16(str.Remove(str.IndexOf("\r\n")));
                        Console.WriteLine("Function Code: " + FunctionCode.ToString("X"));
                        MessageBox.Show("Function Code: " + FunctionCode.ToString("X"));

                        str = str.Remove(0, str.IndexOf("\r\n") + 17);
                        ExceptionCode = str.Remove(str.IndexOf("-"));
                        switch (ExceptionCode.Trim())
                        {
                            case "1":
                            Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> Illegal function!");
                            MessageBox.Show("Exception Code: " + ExceptionCode.Trim() + "----> Illegal function!");
                            break;
                            case "2":
                            Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> Illegal data address!");
                            MessageBox.Show("Exception Code: " + ExceptionCode.Trim() + "----> Illegal data address!");
                            break;
                            case "3":
                            Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> Illegal data value!");
                            MessageBox.Show("Exception Code: " + ExceptionCode.Trim() + "----> Illegal data value!");
                            break;
                            case "4":
                            Console.WriteLine("Exception Code: " + ExceptionCode.Trim() + "----> Slave device failure!");
                            MessageBox.Show("Exception Code: " + ExceptionCode.Trim() + "----> Slave device failure!");
                            break;

                        }
                        this.UpdateBar.Value = this.UpdateBar.Minimum;
                        this.UpdateBtn.Enabled = false;
                        this.choosebth.Enabled = true;
                        return;
                    }
                }
            }
        }
        #endregion

        private void txtReceiveMessage_TextChanged(object sender, EventArgs e)
        {
            if (txtReceiveMessage.TextLength > 3000)
            {
                txtReceiveMessage.Text = "0";
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {

        }
        private  void SubscribeBut_Click(object sender, EventArgs e)

        {
            
        }

        [Obsolete]
        private async void btOpenCOM_Click(object sender, EventArgs e)
        {
            if (LOCALDEBUG == true)
            {
                comPort.PortName = "COM6";
                comPort.BaudRate = 9600;
                comPort.Parity = Parity.None;
                comPort.StopBits = StopBits.One;
                comPort.DataBits = 8;
            }
            else
            {
                if (cmbPort.Text == "")
                {
                    MessageBox.Show("串口打开错误");
                    return;
                }
                comPort.PortName = cmbPort.Text;
                comPort.BaudRate = int.Parse(cmbBaud.Text);
                comPort.DataBits = int.Parse(cmbDataBit.Text);
                if (cmbParity.Text.Substring(0, 1) == "0")
                {
                    comPort.Parity = Parity.None;
                }
                else if (cmbParity.Text.Substring(0, 1) == "1")
                {
                    comPort.Parity = Parity.Odd;
                }
                else if (cmbParity.Text.Substring(0, 1) == "2")
                {
                    comPort.Parity = Parity.Even;
                }
                if (cmbStopBit.Text == "0")
                {
                    comPort.StopBits = StopBits.None;
                }
                else if (cmbStopBit.Text == "1")
                {
                    comPort.StopBits = StopBits.One;
                }
            }
            try
            {
                comPort.Open();
                isReconnect = true;
                SetMqtt();
                MQTT_thread = new MethodInvoker(Sendout);
                MQTT_thread.BeginInvoke(null, null);
                await Task.Run(async () => { await ConnectMqttServerAsync(); });
                ModbusComm.Modbus = ModbusSerialMaster.CreateRtu(comPort);
                ModbusComm.Modbus.Transport.Retries = 0;
                ModbusComm.Modbus.Transport.ReadTimeout = 1000;
                ModbusComm.Modbus.Transport.WriteTimeout = 1000;
                ModbusComm.Modbus.Transport.WaitToRetryMilliseconds = 0;

                modbus_Timer.Enabled = true;
                btOpenCOM.Enabled = false;
                btCloseCOM.Enabled = true;
                if (bCretaThead == false)
                {
                    bCretaThead = true;
                    ModbusPollThread = new Thread(vModbusPoll);
                    ModbusPollThread.Start();
                    ModbusPollThread.Priority = ThreadPriority.Normal;


                    ModbusControlThread = new Thread(ModualControl.vControl_Poll);
                    ModbusControlThread.Start();
                    ModbusControlThread.Priority = ThreadPriority.BelowNormal;

                    MqttReceiveThread = new Thread(vMqtt_Receive_Handle);
                    MqttReceiveThread.Start();
                    MqttReceiveThread.Priority = ThreadPriority.AboveNormal;

                   Task task1 = Task.Factory.StartNew(async() => {await ModualControl.vControl_Res_Poll();});
                }
                else
                {
                    ModbusPollThread.Resume();
                }
                totxt.Log(DateTime.Now.ToString() + " =>Open " + comPort.PortName + " sucessfully!");
                await Subscribe();
            }
            catch (Exception ex)
            {
                totxt.Log("Error: " + ex.Message);
                MessageBox.Show("Error: " + ex.Message);
                return;
            }
        }
        private async void run()
        {
                comPort.PortName = "COM6";
                comPort.BaudRate = 9600;
                comPort.Parity = Parity.None;
                comPort.StopBits = StopBits.One;
                comPort.DataBits = 8;

            try
            {
                comPort.Open();
                isReconnect = true;
                SetMqtt();
                MQTT_thread = new MethodInvoker(Sendout);
                MQTT_thread.BeginInvoke(null, null);
                await Task.Run(async () => { await ConnectMqttServerAsync(); });
                ModbusComm.Modbus = ModbusSerialMaster.CreateRtu(comPort);
                ModbusComm.Modbus.Transport.Retries = 0;
                ModbusComm.Modbus.Transport.ReadTimeout = 1000;
                ModbusComm.Modbus.Transport.WriteTimeout = 1000;
                ModbusComm.Modbus.Transport.WaitToRetryMilliseconds = 0;

                t_AutoControl = new Thread(AtuoControl_run);
                t_AutoControl.IsBackground = true;
                t_AutoControl.Start();

                modbus_Timer.Enabled = true;
                btOpenCOM.Enabled = false;
                btCloseCOM.Enabled = true;
                if (bCretaThead == false)
                {
                    bCretaThead = true;
                    ModbusPollThread = new Thread(vModbusPoll);
                    ModbusPollThread.Start();

                    ModbusControlThread = new Thread(ModualControl.vControl_Poll);
                    ModbusControlThread.Start();
                }
                else
                {
                    ModbusPollThread.Resume();
                }
                totxt.Log(DateTime.Now.ToString() + " =>Open " + comPort.PortName + " sucessfully!");
                await Subscribe();
            }
            catch (Exception ex)
            {
                totxt.Log("Error: " + ex.Message);
                MessageBox.Show("Error: " + ex.Message);
                return;
            }
        }
        [Obsolete]
        private void btCloseCOM_Click(object sender, EventArgs e)
        {
            //Close comport first,then stop and dispose slave.  
            if (ModbusPollThread.IsAlive == true)
                ModbusPollThread.Suspend();
            isReconnect = false;
            modbus_Timer.Enabled = false;
            btOpenCOM.Enabled = true;
            btCloseCOM.Enabled = false;
            Task.Run(async () => { await mqttClient.DisconnectAsync(); });
            comPort.Close();
            totxt.Log(DateTime.Now.ToString() + " =>Disconnect " + comPort.PortName);
        }

        private void AtuoControl_run()
        {
            while (true)
            {
                AutoControl.T_AutoControl();
            }
        }
    }

}
